Bug 991578 - HHH-8390 Foreign key reference generated before unique constraint exists
HHH-8390 Foreign key reference generated before unique constraint exists
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: Hibernate (Show other bugs)
Unspecified Unspecified
high Severity high
: ER1
: EAP 6.2.0
Assigned To: Brett Meyer
Zbyněk Roubalík
Russell Dickenson
Depends On:
Blocks: 991581 eap62-upgrade-hibernate425
  Show dependency treegraph
Reported: 2013-08-02 14:47 EDT by Ricardo Martinelli de Oliveira
Modified: 2015-09-01 00:00 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Creating a schema in which a foreign key was declared before it was defined as unique or as a primary key, would fail on Oracle and possibly other dialects. This issue has been fixed in this release of JBoss EAP 6 by forcing unique key constraints to be created before foreign key constraints as part of the schema export process. As a result, exported schemas should no longer fail on Oracle because of a foreign key being declared before a unique constraint exists.
Story Points: ---
Clone Of:
: 991581 (view as bug list)
Last Closed: 2013-12-15 11:13:23 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Ricardo Martinelli de Oliveira 2013-08-02 14:47:12 EDT
In H2 the generated schema works:
[main            ] DEBUG  - 18:27:01,763 - org.hibernate.SQL: 
    create table Item (
        id bigint not null,
        name varchar(255),
        SELLER_CUSTOMERNR varchar(255),
        primary key (id)
[main            ] DEBUG  - 18:27:01,769 - org.hibernate.SQL: 
    create table USERS (
        id bigint not null,
        customerNr varchar(255),
        primary key (id)
[main            ] DEBUG  - 18:27:01,769 - org.hibernate.SQL: 
    alter table Item 
        add constraint FK_76d41162ea614944b8333c7c440 
        foreign key (SELLER_CUSTOMERNR) 
        references USERS (customerNr)
[main            ] DEBUG  - 18:27:01,775 - org.hibernate.SQL: 
    alter table USERS 
        add constraint UK_8a5ec890d05a4545a1e9660dea0 unique (customerNr)
On Oracle this fails, as the foreign key reference is actually checked before the UNIQUE constraint is generated.
Comment 2 Zbyněk Roubalík 2013-09-23 07:23:42 EDT
EAP 6.2.0.ER1

Note You need to log in before you can comment on or make changes to this bug.